VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "A Class that will handle the complexities of the Windows Regostry"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'    Blue Ice HTML Editor
'    Program Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

' This class was published by the Visual Basic Programmer's Journal
' (http://www.devx.com), and its copyright is not held by this program's
' author.
'
Option Explicit

'local variable(s) to hold property value(s)
Private m_varRoot As Long 'local copy
Private m_varKey As String 'local copy
Private m_varAutoCreate As Boolean 'local copy
Private m_varDefault As String 'local copy
Private m_varSubKeyCount As Integer 'local copy
Private m_lAccessType As Long
Private m_iSubKeyCount As Integer

Private m_nKeyNamesCnt As Integer
Private m_lOpenKey As Long
Private m_aStringData() As String
Private m_aSubKeyData() As String

Public Enum RootValues
    HkeyClassRoot = &H80000000
    HkeyCurrentUser = &H80000001
    HkeyLocalMachine = &H80000002
    HkeyUsers = &H80000003
    HkeyCurrentConfig = -1
    HkeyDynData = -1
End Enum

Public Enum RegErrors
    REG_ERROR_OPEN_FAIL = vbObjectError + 512 + 1
    REG_ERROR_CLOSE_FAIL = vbObjectError + 512 + 2
    REG_ERROR_CREATE_FAIL = vbObjectError + 512 + 3
    REG_ERROR_READ_FAIL = vbObjectError + 512 + 4
    REG_ERROR_NOKEY = vbObjectError + 512 + 5
    REG_ERROR_NOSUBKEY = vbObjectError + 512 + 6
    REG_ERROR_NOLETPROPERTY = vbObjectError + 512 + 7
    REG_ERROR_BINARY_DATA = vbObjectError + 512 + 8
    REG_ERROR_UNKNOWN = vbObjectError + 512 + 9
End Enum

Const HKEY_PERFORMANCE_DATA = &H80000004
Const MAX_PATH = 256&
Const SYNCHRONIZE = &H100000

Const KEY_CREATE_LINK = &H20
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
'const KEY_EXECUTE =
Const KEY_NOTIFY = &H10
Const KEY_QUERY_VALUE = &H1         'Permission to query subkey data.
Const KEY_READ = KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Const KEY_SET_VALUE = &H2           'Permission to set subkey data.
Const KEY_WRITE = KEY_SET_VALUE Or KEY_CREATE_SUB_KEY
Const KEY_ALL_ACCESS = KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_SUB_KEY Or KEY_CREATE_LINK Or KEY_SET_VALUE

'Open/Create Options
Const REG_OPTION_NON_VOLATILE = 0&
Const REG_OPTION_VOLATILE = &H1

'Key creation/open disposition
Const REG_CREATED_NEW_KEY = &H1
Const REG_OPENED_EXISTING_KEY = &H2

'masks for the predefined standard access types
'Const STANDARD_RIGHTS_ALL = &H1F0000
Const SPECIFIC_RIGHTS_ALL = &HFFFF

Const STANDARD_RIGHTS_READ = &H20000
Const STANDARD_RIGHTS_WRITE = &H20000
Const STANDARD_RIGHTS_EXECUTE = &H20000
Const STANDARD_RIGHTS_REQUIRED = &HF0000
Const STANDARD_RIGHTS_ALL = &H1F0000
'Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
'Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))

'Define severity codes
Const ERROR_SUCCESS = 0&
Const ERROR_ACCESS_DENIED = 5
Const ERROR_NO_MORE_ITEMS = 259
Const ERROR_MORE_DATA = 234
Const ERROR_INVALID_PARAMETER = 87
Const REG_VALUE_NOT_SET = 2

Public Enum RegTypes
    RegNonee = 0
    RegSz = 1
    RegExpandSz = 2
    RegBinary = 3
    RegDword = 4
    RegDwordLittleEndian = 4
    RegDwordBigEndian = 5
    RegLink = 6
    RegMultiSz = 7
    RegResourceList = 8
    RegFulResourceDesc = 9
End Enum

Private Type SECURITY_ATTRIBUTES
  nLength As Long
  lpSecurityDescriptor As Long
  bInheritHandle As Long
End Type

Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Private Declare Function RegQueryInfoKey Lib "advapi32" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftlLastWriteTime As FILETIME) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal szData As String, ByVal cbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal szData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
Private Declare Function RegEnumValueStr Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function GetWinPlatform Lib "VB5STKIT.DLL" () As Long


Private Function DeleteKeyAdv(sKey As String) As Long
    Dim lIndex As Long
    Dim lpftLastWriteTime As FILETIME
    
    Dim lRet As Long
    Dim lRet1 As Long
    Dim lValuename As Long
    Dim strValueName As String
    Dim lOpenKey As Long
    Dim sPrevKey As String
    
    lRet1 = -1
    sPrevKey = m_varKey
    If ERROR_SUCCESS = RegOpenKeyEx(m_varRoot, m_varKey & "\" & sKey, 0, KEY_ALL_ACCESS, lOpenKey) Then
        lIndex = 0
        Do
            lValuename = 255
            strValueName = String$(lValuename, 0)
            lRet = RegEnumKeyEx(lOpenKey, lIndex, strValueName, lValuename, 0&, 0&, 0&, lpftLastWriteTime)
            If lRet = ERROR_NO_MORE_ITEMS Then
                RegCloseKey lOpenKey
                If ERROR_SUCCESS = RegOpenKeyEx(m_varRoot, m_varKey, 0, KEY_ALL_ACCESS, lOpenKey) Then
                    lRet1 = RegDeleteKey(lOpenKey, sKey)
                End If
            Else
                Dim S As String
                m_varKey = m_varKey & "\" & sKey
                S = Left$(strValueName, lValuename)
                lRet1 = DeleteKeyAdv(S)
                m_varKey = sPrevKey
            End If
        Loop While lRet <> ERROR_NO_MORE_ITEMS
        
        RegCloseKey lOpenKey
    End If
    DeleteKeyAdv = lRet1

End Function

Public Function DeleteValue(sValue As String) As Boolean
    Dim lRet As Long

On Error GoTo DeleteValue_Error
    
    DeleteValue = False
    OpenKey
    If RegDeleteValue(m_lOpenKey, sValue) = ERROR_SUCCESS Then DeleteValue = True
    CloseKey
    GetKeyInfo
    
DeleteValue_Exit:
    Exit Function
    
DeleteValue_Error:
    DeleteValue = False
    GoTo DeleteValue_Exit
    
End Function


Public Function GetName(ByVal iRequest As Integer) As String
    If iRequest >= LBound(m_aStringData, 2) And iRequest <= UBound(m_aStringData, 2) Then
        GetName = m_aStringData(0, CInt(iRequest))
    Else
        GetName = ""
    End If
End Function

Public Function GetSubKey(iIndex As Integer) As String
    If iIndex >= LBound(m_aSubKeyData) And iIndex <= UBound(m_aSubKeyData) Then
        GetSubKey = m_aSubKeyData(iIndex + 1)
    End If
End Function

Public Function GetValue(ByVal vRequest As Variant) As String
    
On Error GoTo GetValue_Error

    If VarType(vRequest) = vbInteger Then
       GetValue = m_aStringData(1, CInt(vRequest))
    Else
        Dim I As Integer
        I = LBound(m_aStringData, 2)
        
        Do
            If UCase$(m_aStringData(0, I)) = UCase$(vRequest) Then
                GetValue = m_aStringData(1, I)
                Exit Do
            End If
            I = I + 1
        Loop While I <= UBound(m_aStringData, 2)
    End If
        
GetValue_Exit:
    Exit Function
    
GetValue_Error:
    MsgBox Err.Description, , Err.Source
    GoTo GetValue_Exit
    
End Function


Public Function DeleteKey(ByVal KeyName As String) As Boolean
On Error GoTo DeleteKey_Error
 
    DeleteKeyAdv KeyName

DeleteKey_Exit:
    Exit Function
 
DeleteKey_Error:
    GoTo DeleteKey_Exit
 
End Function
Public Function Create(ByVal KeyName As String, Optional ByVal sKeyName As Variant, Optional ByVal sValue As String) As Integer

On Error GoTo CreateKey_Error
    Create = 0
    
    If m_varKey <> KeyName Then
        m_varKey = m_varKey & "\" & KeyName
    End If
    
    Create = CreateEx
    If 0 <> Create Then
        If Not IsMissing(sKeyName) And Not IsMissing(sValue) Then
            If False = SetValue(sKeyName, sValue) Then  ' set value if optionals are present
                MsgBox "Could not set value"
            End If
        End If
        Create = True
    End If
    
    CloseKey
       
CreateKey_Exit:
    Exit Function
 
CreateKey_Error:
    GoTo CreateKey_Exit
 
End Function

Private Function CreateEx() As Integer
    Dim lRet As Long
    Dim phkResult As Long
    Dim lpdwDisposition As Long
    Dim sa As SECURITY_ATTRIBUTES
    
On Error GoTo CreateEx_Error

    CreateEx = 0
    lRet = RegCreateKeyEx(m_varRoot, m_varKey, 0, vbNull, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, sa, m_lOpenKey, lpdwDisposition)

    Select Case lRet
        Case 0
            CreateEx = lpdwDisposition
        Case 1010
            Err.Raise REG_ERROR_OPEN_FAIL, "CreateEx", "Cannot Open Parent Key"
        Case Else
            Err.Raise REG_ERROR_UNKNOWN, "CreateEx", "Unknown Error: " & lRet
    End Select
    
    Exit Function
    
CreateEx_Error:
    Err.Raise REG_ERROR_UNKNOWN, "CreateEx", "Unknown Error: " & lRet
    
End Function

Private Function OpenKey(Optional lAccess As Long = KEY_READ Or KEY_WRITE) As Boolean
    Dim lRet As Long
 
    OpenKey = False
    If m_varRoot = 0 Or Len(m_varKey) = 0 Then
        m_lOpenKey = 0
    Else
        ' close any open key
        CloseKey
        If m_varAutoCreate = True Then
            Dim iRet As Integer
            iRet = CreateEx
            If REG_OPENED_EXISTING_KEY = iRet Or REG_CREATED_NEW_KEY = iRet Then
                OpenKey = True
            End If
        Else
            If ERROR_SUCCESS = RegOpenKeyEx(m_varRoot, m_varKey, 0, lAccess, m_lOpenKey) Then
                OpenKey = True
            End If
        End If
    End If
End Function

Private Sub CloseKey()
 
    If m_lOpenKey <> 0 Then
        RegCloseKey (m_lOpenKey)
        m_lOpenKey = 0
    End If
 
End Sub

Private Sub GetKeyInfo()

On Error GoTo GetKeyInfo_Error:
 
    Dim lpClass As String
    Dim lpcbClass As Long
    Dim lpcSubKeys As Long
    Dim lpcbMaxSubKeyLen As Long
    Dim lpcbMaxClassLen As Long
    Dim lpcValueCount As Long
    Dim lpcbMaxValueNameLen As Long
    Dim lpcbMaxValueLen As Long
    Dim lpcbSecurityDescriptor As Long
    Dim lpftLastWriteTime As FILETIME
    Dim lRet As Long
    Dim lpReserved As Long

    On Error GoTo GetKeyInfo_Error
   
    ' Close any key that may have been left open
    CloseKey
    If m_varAutoCreate = True Then
        If 0 = CreateEx Then
            Err.Raise 1000, "GetKeyInfo", "Unable to create Key"
        End If
    Else
        If ERROR_SUCCESS <> RegOpenKeyEx(m_varRoot, m_varKey, 0, m_lAccessType, m_lOpenKey) Then
            GoTo GetKeyInfo_Error
        End If
    End If
   
    lpClass = String$(25, 0)
    lpcbClass = 25
    lpReserved = 0
    
    lRet = RegQueryInfoKey(m_lOpenKey, lpClass, lpcbClass, 0&, _
        lpcSubKeys, lpcbMaxSubKeyLen, lpcbMaxClassLen, _
        lpcValueCount, lpcbMaxValueNameLen, lpcbMaxValueLen, _
        lpcbSecurityDescriptor, lpftLastWriteTime)
 
    Dim lIndex As Long, lValuename As Long, lType As Long
    Dim lData As Long
    Dim strValueName As String
    Dim strDATA As String
    
    lIndex = 0

    Do
        lRet = RegEnumValue(m_lOpenKey, lIndex, 0&, 0, 0&, lType, 0&, lData)
        If lRet <> ERROR_NO_MORE_ITEMS And lType = RegTypes.RegSz Then
            lValuename = lpcbMaxValueNameLen + 1
            lData = lpcbMaxValueLen + 1
            strDATA = String$(lData, 0)
            strValueName = String$(lValuename, 0)
            lRet = RegEnumValueStr(m_lOpenKey, lIndex, strValueName, lValuename, 0, lType, strDATA, lData)
            strDATA = Left$(strDATA, lData - 1)
            strValueName = Left$(strValueName, lValuename)
            ReDim Preserve m_aStringData(2, UBound(m_aStringData, 2) + 1)
            m_aStringData(0, lIndex) = strValueName
            m_aStringData(1, lIndex) = strDATA
            lIndex = lIndex + 1
        End If
    Loop While lRet = ERROR_SUCCESS
    m_nKeyNamesCnt = lIndex
 
    lIndex = 0
    Do
        lValuename = lpcbMaxSubKeyLen + 1
        strValueName = String$(lValuename, 0)
        lRet = RegEnumKeyEx(m_lOpenKey, lIndex, strValueName, lValuename, 0&, 0&, 0&, lpftLastWriteTime)
        If lRet <> ERROR_NO_MORE_ITEMS Then
            ReDim Preserve m_aSubKeyData(UBound(m_aSubKeyData) + 1)
            m_aSubKeyData(UBound(m_aSubKeyData)) = Left$(strValueName, lValuename)
            lIndex = lIndex + 1
        End If
    Loop While lRet <> ERROR_NO_MORE_ITEMS
    m_iSubKeyCount = lIndex
    
GetKeyInfo_Exit:
    CloseKey
    Exit Sub
    
GetKeyInfo_Error:
    Err.Raise REG_ERROR_OPEN_FAIL, "GetKeyInfo", "Unable to open Key"
End Sub

Public Sub Refresh()
    GetKeyInfo
End Sub

Public Function SetValue(sKeyName As Variant, sValue As String) As Boolean
    Dim lRet As Long
    Dim lLength As Long
    Dim sTemp As String
    Dim iTemp As Integer
    
    lLength = Len(sValue) + 1
    If VarType(sKeyName) = vbInteger Then
        iTemp = CInt(sKeyName)
        If LBound(m_aStringData, 2) >= iTemp And UBound(m_aStringData, 2) <= iTemp Then
            sTemp = m_aStringData(iTemp)
        Else
            sTemp = ""
        End If
    Else
        sTemp = CStr(sKeyName)
    End If
    
    If True = OpenKey(KEY_WRITE) Then
        SetValue = True
        lRet = RegSetValueEx(m_lOpenKey, sTemp, 0, RegTypes.RegSz, sValue, lLength)
'        lRet = RegSetValueEx(m_lOpenKey, sKeyName, 0, RegTypes.RegSz, sValue, lLength)
        If lRet <> ERROR_SUCCESS Then
            SetValue = False
            MsgBox "Couldn't write new value: " & sValue & _
                " in value " & CStr(sKeyName), vbCritical, "Registry Error"
        End If
        CloseKey
    End If
    
End Function

Public Property Let Default(ByVal strKeyString As String)
    On Error GoTo DefaultLet_Error
 
DefaultLet_Exit:
    Exit Property
 
DefaultLet_Error:
    GoTo DefaultLet_Exit
 
End Property

Public Property Let ValueCount(vl As Integer)
    Err.Raise REG_ERROR_NOLETPROPERTY, "CRegistry.Let ValueCount", "The Let Property is not available"
End Property

Public Property Get ValueCount() As Integer
    ValueCount = m_nKeyNamesCnt
End Property

Public Property Get Default() As String
On Error GoTo DefaultGet_Error
 
    Default = m_varDefault
 
DefaultGet_Exit:
    Exit Property
 
DefaultGet_Error:
    On Error GoTo DefaultGet_Exit
 
End Property



Public Property Let AutoCreate(ByVal vData As Boolean)
 
On Error GoTo AutoCreateLet_Error
 
    m_varAutoCreate = vData
 
AutoCreateLet_Exit:
    Exit Property
 
AutoCreateLet_Error:
    GoTo AutoCreateLet_Exit
 
End Property


Public Property Get AutoCreate() As Boolean
 
On Error GoTo AutoCreateGet_Error
 
    AutoCreate = m_varAutoCreate
 
AutoCreateGet_Exit:
    Exit Property
 
AutoCreateGet_Error:
    GoTo AutoCreateGet_Exit
 
End Property







Public Property Let key(ByVal vData As String)
 
On Error GoTo KeyLet_Error
 
    m_varKey = vData
    GetKeyInfo
 
KeyLet_Exit:
    Exit Property
 
KeyLet_Error:
    Err.Raise Err.Number
 
End Property


Public Property Get key() As String
 
On Error GoTo GetKey_Error
 
    key = m_varKey
 
GetKey_Exit:
    Exit Property
 
 
GetKey_Error:
    GoTo GetKey_Exit
 
End Property


Public Property Let root(ByVal vData As Long)
 
On Error GoTo RootLet_Error
 
    m_varRoot = vData
    OpenKey
 
RootLet_Exit:
    Exit Property
 
 
RootLet_Error:
    GoTo RootLet_Exit
 
End Property


Public Property Get root() As Long
 
On Error GoTo RootGet_Error
 
    root = m_varRoot
 
RootGet_Exit:
    Exit Property
 
 
RootGet_Error:
    GoTo RootGet_Exit
 
End Property


Private Sub Class_Initialize()
    m_varAutoCreate = True
    m_lAccessType = KEY_READ Or KEY_WRITE
    root = HkeyLocalMachine
    ReDim m_aStringData(2, 0)
    ReDim m_aSubKeyData(0)
End Sub



Public Property Get SubKeyCount() As Integer
    SubKeyCount = m_iSubKeyCount
End Property

Public Property Let SubKeyCount(ByVal iNewValue As Integer)
    m_iSubKeyCount = iNewValue
End Property
