Attribute VB_Name = "modCustomApps"
'    Blue Ice HTML Editor
'    Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

' This sub adds a custom application to the collection.
' If it already exists, it is simply modified.
' This system of storing the apps is used because it does
' not require the user to enter them in a particular order.
'
Public Sub SetApp(AppIndex As Integer, Path$, Desc$)
Dim I%
    ' The Dreaded GOTO?
    If CustomApps.Count = 0 Then GoTo NewApp
    
    For I = 1 To CustomApps.Count
        If CustomApps(I).Number = AppIndex Then
            If Len(Path$) = 0 Then
                ' Delete the app
                CustomApps.Remove CStr(AppIndex)
            Else
                CustomApps(I).Path = Path$
                CustomApps(I).Description = Desc$
            End If
            
            Exit Sub
        End If
    Next I

NewApp:
    If Len(Path$) = 0 Then Exit Sub
    
    ' If we get here, item does not exist in collection
    
    Dim CA As New CCustomApp
    CA.Path = Path$
    CA.Description = Desc$
    CA.Number = AppIndex
    CustomApps.Add CA, CStr(AppIndex)
End Sub

Public Sub LoadApps()
Dim A$, CA As CCustomApp, C%, L%, N$
    If Len(Dir(AppPath & "apps.dat")) = 0 Then Exit Sub
    
    Open AppPath & "apps.dat" For Input As #1
    L = 1
    While Not EOF(1)
        Set CA = New CCustomApp
        Line Input #1, A$
        C = InStr(A$, "**")
        CA.Number = CInt(Left$(A$, 1))
        CA.Path = Mid$(A$, 3, C - 3)
        CA.Description = Right$(A$, Len(A$) - C - 1)
        
        CustomApps.Add CA, CStr(CA.Number)
        L = L + 1
    Wend
    
    Close #1
End Sub

Public Sub SaveApps()
Dim A$, CA As CCustomApp, I%
    If CustomApps.Count = 0 Then Exit Sub
    
    Open AppPath & "apps.dat" For Output As #1
    
    For Each CA In CustomApps
        If Len(CA.Path) > 0 Then Print #1, CStr(CA.Number) & ":"; CA.Path & "**" & CA.Description
    Next CA
    
    Close #1
End Sub

