Attribute VB_Name = "modGradientTitle"
'    Blue Ice HTML Editor
'    Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

Public Function CaptionColor(Optional StartColor As Long = -1) As Long
Dim R%, G%, B%, TotalC%
    If StartColor = -1 Then StartColor = GStartColor
    ExtractRGB StartColor, R, G, B
    
    TotalC = R + G + B
    If TotalC < 210 Then
        CaptionColor = vbWhite
    Else
        CaptionColor = vbBlack
    End If
End Function

Public Sub SetTitlebar(pTitle As PictureBox, lTitle As Label)
    Fade pTitle, GStartColor, GEndColor, False
    lTitle.ForeColor = CaptionColor()
End Sub

' This function draws a gradient fill. It is a fixed version
' of an algorithm at codearchive.com by a French guy. The
' variables C[R,G,B] are now Double: otherwise no gradient
' effect occurs when the colors are too close together and
' TotalDistance is too high.
'
Public Sub Fade(obj As Object, StartColour As Long, _
    EndColor As Long, TopToBottom As Boolean)
Dim difR%, difG%, difB%
Dim R1%, G1%, B1%, R2%, G2%, B2%
Dim TotalDistance%, OldScale%, I%
Dim CR As Double, CG As Double, CB As Double

    OldScale = obj.ScaleMode
    obj.ScaleMode = vbPixels
    
    ' Extrude the necessary values using functions in frmColor
    ExtractRGB StartColour, R1, G1, B1
    ExtractRGB EndColor, R2, G2, B2
    
    difR = R2 - R1
    difG = G2 - G1
    difB = B2 - B1
    
    CR = R1
    CG = G1
    CB = B1
      
    If TopToBottom = True Then
        TotalDistance = obj.ScaleHeight
    Else
        TotalDistance = obj.ScaleWidth
    End If
        
    For I = 0 To TotalDistance
        CR = CR + (difR / TotalDistance)
        CG = CG + (difG / TotalDistance)
        CB = CB + (difB / TotalDistance)
        
        CR = IIf(CR < 0, 0, CR)
        CG = IIf(CG < 0, 0, CG)
        CB = IIf(CB < 0, 0, CB)
    
        If TopToBottom Then
            obj.Line (0, I)-(obj.ScaleWidth, I), RGB(CR, CG, CB)
        Else
            obj.Line (I, 0)-(I, obj.ScaleHeight), RGB(CR, CG, CB)
        End If
    Next
    
    obj.ScaleMode = OldScale
End Sub

' Extracts the RGB values from a VBA Long integer
' representing the combined values
'
Public Sub ExtractRGB(ColorVal, R, G, B)
    R = ColorVal And &HFF
    G = (ColorVal \ &H100) And &HFF
    B = (ColorVal \ &H10000) And &HFF
End Sub

